<?php

use Quivers\Models\Settings\StripeSettings as StripeSettingsModel;
use Quivers\Components\ConfigProvider;

class Shopware_Controllers_Backend_StripeSettings extends Shopware_Controllers_Backend_Application
{
    /**
     * {@inheritdoc}
     */
	protected $model = StripeSettingsModel::class;
    
    public function detailAction()
    {
        $settings = $this->getSettings();
        if ($settings !== null) {
            $this->view->assign('stripe_settings', $settings->toArray());
        }
        else{
            $settings = [];
            $this->view->assign('stripe_settings', $settings);
        }
    }

    public function getSettings()
    {
        /** @var StripeSettings $stripeSettings */
        $stripeSettings = $this->getRepository()->findAll();
        return $stripeSettings[0];
    }
}